//
//  BasicFiltersViewController.swift
//  CoreImage
//
//  Created by Michael Gazzola on 3/29/15.
//  Copyright (c) 2015 Michael Gazzola. All rights reserved.
//

import CoreImage
import UIKit

class BasicFiltersViewController: UIViewController {

    @IBOutlet var imageView: UIImageView!
    let image = UIImage(named: "img1.jpg")
    
    override func viewDidLoad() {
        super.viewDidLoad()
        self.imageView.image = image
    }
    
    @IBAction func applyFilter(sender: AnyObject) {
        //  1) Make a CIImage
        //  2) Make a CIFilter object with
        //     the image as parameter.
        //  3) Output as UIImage.
        let image_ = CIImage(image: self.image)
        let filter = CIFilter(name: "CIPhotoEffectMono",
            withInputParameters:
                [kCIInputImageKey : image_])
        let filter2 = CIFilter(name: "CIVortexDistortion",
            withInputParameters:
                [kCIInputImageKey : filter.outputImage,
                 kCIInputCenterKey : CIVector(x: self.image!.size.width / 2,
                                              y: self.image!.size.height / 2),
                 kCIInputAngleKey : 180.0])
        let modifiedImage = UIImage(CIImage: filter2.outputImage)
        self.imageView.image = modifiedImage
    }
}
