//
//  DynamicFiltersViewController.swift
//  CoreImage
//
//  Created by Michael Gazzola on 3/30/15.
//  Copyright (c) 2015 Michael Gazzola. All rights reserved.
//

import CoreImage
import UIKit

class DynamicFiltersViewController: UIViewController {
    
    @IBOutlet var imageView: UIImageView!
    let image = UIImage(named: "img1.jpg")
    
    // Need to keep track of these things:
    var context = CIContext(options: nil)
    var filter = CIFilter(name: "CITwirlDistortion")
    
    override func viewDidLoad() {
        super.viewDidLoad()
        let image_ = CIImage(image: self.image)
        self.filter.setValue(image_, forKey: kCIInputImageKey)
        self.filter.setValue(CIVector(x: self.image!.size.width / 2,
            y: self.image!.size.height / 2),
            forKey: kCIInputCenterKey)
        
        self.createImageWithDistortionAngle(CGFloat(M_PI))
    }
    
    func createImageWithDistortionAngle(angle: CGFloat) {
        self.filter.setValue(angle, forKey: kCIInputAngleKey)
        let cgImage = self.context.createCGImage(self.filter.outputImage, fromRect: self.filter.outputImage.extent())
        self.imageView.image = UIImage(CGImage: cgImage)
    }
    
    @IBAction func sliderValueDidChange(sender: UISlider) {
        let sliderValue = sender.value
        self.createImageWithDistortionAngle(CGFloat(sliderValue) * 2 * CGFloat(M_PI))
    }
}
