//
//  MainTableViewController.swift
//  CoreImage
//
//  Created by Michael Gazzola on 3/29/15.
//  Copyright (c) 2015 Michael Gazzola. All rights reserved.
//

import Foundation
import UIKit

class MainTableViewController: UITableViewController, UITableViewDataSource {
    
    let cellStrings = ["Basic Filters",
                       "Dynamic Filters",
                       "Advanced Filtering Techniques",
                       "Face Detection"]
    let cellTargets = ["basicFilters",
                       "dynamicFilters",
                       "advancedFilteringTechniques",
                       "faceDetection"]

    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    override func numberOfSectionsInTableView(tableView: UITableView) -> Int {
        return 1
    }
    
    override func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return self.cellStrings.count
    }

    override func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
        let cellNumber = indexPath.row
        let cell = self.tableView.dequeueReusableCellWithIdentifier("mainCell")
                        as? MainTableViewCell ?? MainTableViewCell()
        cell.cellText.text = self.cellStrings[cellNumber]
        return cell
    }
    
    override func tableView(tableView: UITableView, titleForHeaderInSection section: Int) -> String? {
        return "CoreImage Examples"
    }
    
    override func tableView(tableView: UITableView, didSelectRowAtIndexPath indexPath: NSIndexPath) {
        let cellNumber = indexPath.row
        self.performSegueWithIdentifier(cellTargets[cellNumber], sender: self)
    }
}

